Launchpad voucher redemption fails with unactivated vouchers

Bug #597754 reported by Brad Crittenden on 2010-06-23
32
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Canonical Salesforce
Medium
James Jesudason
Launchpad itself
Low
Brad Crittenden

Bug Description

The process that imports newly purchased items from the shop and creates them in Salesforce was converted last Friday. Since then Launchpad users have complained about errors stating ""The voucher could not be redeemed at this time."

2010-06-23 14:38:50+0000 [HTTPChannel,43,91.189.90.221] Getting vouchers for openid xxxx
2010-06-23 14:38:50+0000 [HTTPChannel,43,91.189.90.221] INFO: Starting getVouchers
2010-06-23 14:38:51+0000 [HTTPChannel,43,91.189.90.221] INFO: Finished getVouchers
2010-06-23 14:38:51+0000 [HTTPChannel,43,91.189.90.221] Got 1 vouchers for openid xxxx
2010-06-23 14:38:51+0000 [HTTPChannel,43,91.189.90.221] 91.189.90.221 - - [23/Jun/2010:14:38:50 +0000] "POST /RPC2 HTTP/1.0" 200 745 "-" "xmlrpclib.py/1.0.1 (by www.pythonware.com)"
2010-06-23 14:38:51+0000 [HTTPChannel,44,91.189.90.221] INFO: Starting getVouchers
2010-06-23 14:38:52+0000 [HTTPChannel,44,91.189.90.221] INFO: Finished getVouchers
2010-06-23 14:38:54+0000 [HTTPChannel,44,91.189.90.221] Unhandled Error
        Traceback (most recent call last):
        Failure: canonical.salesforce.voucher.VoucherNotActiveError: Voucher LPCSB12-9xxxx is not an active asset

2010-06-23 14:38:54+0000 [HTTPChannel,44,91.189.90.221] Traceback (most recent call last):
          File "/srv/salesforce/production/production/sfi-salesforce/canonical/salesforce/sfi_proxy/svcutil.py", line 74, in callImpl
            call_response = method_ref(*args)
          File "/srv/salesforce/production/production/sfi-salesforce/canonical/salesforce/sfi_proxy/svc_lpsub.py", line 163, in redeemVoucher
            success = voucher.redeem(redeemer_openid)
          File "/srv/salesforce/production/production/sfi-salesforce/canonical/salesforce/voucher.py", line 98, in redeem
            raise VoucherNotActiveError(msg)
        VoucherNotActiveError: Voucher LPCSB12-9xxxx is not an active asset

According to JamesJ the new shop process is the same as the old. It loops through new assets and creates them in SF. Later it loops over those new assets and activates them. The failure is likely occurring because the request for the voucher happens between creation and activation.

While the process may be the same the timing has changed. The shop import is now being run every 30 minutes where it was run at least every 15 minutes before. Perhaps the processing of more items less frequently has increased the time between creation and activation that is now causing the errors to occur more frequently.

I do see that the same error did occur once in April. We have seen four such errors since Friday.

Related OOPS: OOPS-1633H1081, OOPS-1633O1095

Related branches

Brad Crittenden (bac) on 2010-06-23
visibility: public → private
visibility: private → public
visibility: public → private
Ursula Junque (ursinha) on 2010-06-23
tags: added: oops
description: updated
Brad Crittenden (bac) wrote :

OOPS-1633H1081

Changed in launchpad-registry:
status: New → Triaged
importance: Undecided → Low
affects: canonical-isd → canonical-salesforce
Changed in canonical-salesforce:
assignee: nobody → Neil Messenbird (neil-messenbird)
importance: Undecided → Medium
milestone: none → 10-07
status: New → Triaged
Brad Crittenden (bac) wrote :

It was recently discovered that Salesforce is expiring vouchers that have been purchased but not redeemed within a year's time. Some of the failures seen are due to attempts to redeem expired vouchers.

The one year expiration of unredeemed vouchers was not something we requested in the design of the system. From Launchpad's perspective we'd prefer that mechanism be removed.

See also bug 599707

Brad Crittenden (bac) on 2010-07-03
Changed in launchpad-registry:
milestone: none → 10.07
Curtis Hovey (sinzui) on 2010-07-06
Changed in launchpad-registry:
milestone: 10.07 → 10.08
Changed in canonical-salesforce:
status: Triaged → In Progress
Changed in launchpad-registry:
assignee: nobody → Brad Crittenden (bac)
tags: added: qa-needstesting
Changed in launchpad-registry:
status: Triaged → Fix Committed
Curtis Hovey (sinzui) wrote :

What is the test for this? To ask Joey to confirm he has fewer vouchers now?

Changed in canonical-salesforce:
assignee: Neil Messenbird (neil-messenbird) → James Jesudason (jamesj)
Brad Crittenden (bac) on 2010-07-12
tags: added: qa-bad
removed: qa-needstesting
James Jesudason (jamesj) wrote :

Now changed the schedule so that the import will run every 15 minutes (same as the original Python code).

Download full text (3.4 KiB)

On Jul 11, 2010, at 17:56 , Curtis Hovey wrote:

> What is the test for this? To ask Joey to confirm he has fewer vouchers
> now?

When a person goes to +vouchers the log files on niobium show how many are retrieved. I can compare by going to my +vouchers on product and on edge -- the latter should show fewer.

--bac

>
> --
> Launchpad voucher redemption fails with unactivated vouchers
> https://bugs.launchpad.net/bugs/597754
> You received this bug notification because you are a direct subscriber
> of the bug.
>
> Status in Canonical Salesforce: In Progress
> Status in The Launchpad Registry: Fix Committed
>
> Bug description:
> The process that imports newly purchased items from the shop and creates them in Salesforce was converted last Friday. Since then Launchpad users have complained about errors stating ""The voucher could not be redeemed at this time."
>
> 2010-06-23 14:38:50+0000 [HTTPChannel,43,91.189.90.221] Getting vouchers for openid xxxx
> 2010-06-23 14:38:50+0000 [HTTPChannel,43,91.189.90.221] INFO: Starting getVouchers
> 2010-06-23 14:38:51+0000 [HTTPChannel,43,91.189.90.221] INFO: Finished getVouchers
> 2010-06-23 14:38:51+0000 [HTTPChannel,43,91.189.90.221] Got 1 vouchers for openid xxxx
> 2010-06-23 14:38:51+0000 [HTTPChannel,43,91.189.90.221] 91.189.90.221 - - [23/Jun/2010:14:38:50 +0000] "POST /RPC2 HTTP/1.0" 200 745 "-" "xmlrpclib.py/1.0.1 (by www.pythonware.com)"
> 2010-06-23 14:38:51+0000 [HTTPChannel,44,91.189.90.221] INFO: Starting getVouchers
> 2010-06-23 14:38:52+0000 [HTTPChannel,44,91.189.90.221] INFO: Finished getVouchers
> 2010-06-23 14:38:54+0000 [HTTPChannel,44,91.189.90.221] Unhandled Error
> Traceback (most recent call last):
> Failure: canonical.salesforce.voucher.VoucherNotActiveError: Voucher LPCSB12-9xxxx is not an active asset
>
> 2010-06-23 14:38:54+0000 [HTTPChannel,44,91.189.90.221] Traceback (most recent call last):
> File "/srv/salesforce/production/production/sfi-salesforce/canonical/salesforce/sfi_proxy/svcutil.py", line 74, in callImpl
> call_response = method_ref(*args)
> File "/srv/salesforce/production/production/sfi-salesforce/canonical/salesforce/sfi_proxy/svc_lpsub.py", line 163, in redeemVoucher
> success = voucher.redeem(redeemer_openid)
> File "/srv/salesforce/production/production/sfi-salesforce/canonical/salesforce/voucher.py", line 98, in redeem
> raise VoucherNotActiveError(msg)
> VoucherNotActiveError: Voucher LPCSB12-9xxxx is not an active asset
>
> According to JamesJ the new shop process is the same as the old. It loops through new assets and creates them in SF. Later it loops over those new assets and activates them. The failure is likely occurring because the request for the voucher happens between creation and activation.
>
> While the process may be the same the timing has changed. The shop import is now being run every 30 minutes where it was run at least every 15 minutes before. Perhaps the processing of more items less frequently has increased the time between creation and activation that is now causing the errors to occur more frequently.
>
> I do see that the same error d...

Read more...

Brad Crittenden (bac) on 2010-07-14
tags: added: qa-ok
removed: qa-bad
Changed in canonical-salesforce:
status: In Progress → Fix Released

Fixed released in launchpad-project 10.08.

Curtis Hovey (sinzui) on 2010-08-12
Changed in launchpad-registry:
status: Fix Committed → Fix Released
Curtis Hovey (sinzui) on 2011-10-19
visibility: private → public
Curtis Hovey (sinzui) on 2011-10-25
tags: added: projects salesforce
removed: lp-registry
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers